#include <cstdio>
#include <vector>
#include <string>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>

using namespace std;
char buf[1000000];

struct Pos {
  int tp;
  int sp;
  Pos() {}
  Pos(int a, int c) : tp(a), sp(c) {}

  bool operator==(const Pos &b) const {
    return tp == b.tp && sp == b.sp;
  }
};

namespace std {

template<>
struct hash<Pos> {
  size_t operator()(const Pos& a) const {
    return hash<int>()(a.tp) ^ (hash<int>()(a.sp) << 16);
  }
};

}

// arguments: <input> <out output> <their output>
int main(int argc, char** argv) {
  FILE *f = fopen(argv[1], "r");
  int n, m; fscanf(f, "%d %d ", &n, &m);
  vector<string> nodes;
  for (int i = 0; i < n; i++) {
    fscanf(f, "%s", buf);
    nodes.push_back(string(buf));
  }

  vector<unordered_set<int>> gs(n);
  for (int i = 0; i < m; i++) {
    int a, b; fscanf(f, "%d %d ", &a, &b);
    a--; b--;
    gs[a].insert(b);
  }


  int d, start, end;
  fscanf(f, "%d %d %d ", &d, &start, &end);
  fscanf(f, "%s", buf);
  string target(buf);
  

  FILE *four = fopen(argv[2], "r");
  int ss; fscanf(four, "%d", &ss);

  vector<int> pp;

  FILE *fth = fopen(argv[3], "r");
  int x;
  while (fscanf(fth, "%d", &x)>=1) {
    pp.push_back(x);
  }
  if (pp.size() == 0) {
    printf("Prazdna odpoved\n");
    return 1;
  }
  if (ss == -1) {
    if (pp.size() != 1) {
      printf("Spatna odpoved\n");
      return 1;
    }
    if (pp[0] != -1) {
      printf("Spatna odpoved\n");
      return 1;
    }
    return 0;
  }
  if (pp.size() == 1 && pp[0] == -1) {
    printf("Spatna odpoved\n");
    return 1;
  }
  if (pp[0] != start && pp.back() != end) {
    printf("Spatny zacatek nebo konec\n");
    return 1;    
  }

  string pattern;
  for (int i = 0; i < pp.size(); i++) {
    pp[i]--;
    if (i > 0) {
      if (gs[pp[i-1]].count(pp[i]) == 0) {
        printf("Spatny naslednik\n");
        return 1;
      }
    }
    pattern += nodes[pp[i]];
  }

  deque<pair<Pos, int>> fr;
  fr.push_back(make_pair(Pos(0, 0), 0));
  unordered_map<Pos, int> dists;
  dists[Pos(0,0)] = 0;

  while (!fr.empty()) {
    Pos x = fr.front().first; 
    int dd = fr.front().second; 
    fr.pop_front();
    if (dd > d) continue;
    if (dd > dists[x]) continue;
    if (x.tp == target.size() && x.sp == pattern.size()) {
      return 0;
    }
    if (x.sp < pattern.size()) {
      if (x.tp < target.size()) {
        if (target[x.tp] == pattern[x.sp]) {
          Pos nx(x.tp+1, x.sp+1);
          if (dists.count(nx) == 0 || dists[nx] > dd) {
            fr.push_front(make_pair(nx, dd));
            dists[nx] = dd;
          }
        } else {
          Pos nx(x.tp+1, x.sp+1);
          if (dists.count(nx) == 0) {
            fr.push_back(make_pair(nx, dd+1));
            dists[nx] = dd+1;
          }
        }
      }
      Pos nx(x.tp, x.sp+1);
      if (dists.count(nx) == 0) {
        fr.push_back(make_pair(nx, dd+1));
        dists[nx] = dd+1;
      }
    }
    if (x.tp < target.size()) {
      Pos nx(x.tp+1, x.sp);
      if (dists.count(nx) == 0) {
        fr.push_back(make_pair(nx, dd+1));
        dists[nx] = dd+1;
      }
    }
  }

  printf("Prilis vzdalene od retezce R\n");
  return 1;
}
